org.cpsolver.instructor.criteria

## Class TimeOverlaps

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>
  - - org.cpsolver.instructor.criteria.InstructorSchedulingCriterion
    - - org.cpsolver.instructor.criteria.TimeOverlaps

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<TeachingRequest.Variable,TeachingAssignment,AbstractCriterion.ValueContext>, Criterion<TeachingRequest.Variable,TeachingAssignment>, ExtendedInfoProvider<TeachingRequest.Variable,TeachingAssignment>, InfoProvider<TeachingRequest.Variable,TeachingAssignment>, ModelListener<TeachingRequest.Variable,TeachingAssignment>

      public class TimeOverlaps
      extends InstructorSchedulingCriterion

  Time overlaps. This criterion counts slots during which an instructor has to teach (or attend) two things that are overlapping in time (using `Instructor.share(TeachingRequest)`). The time overlaps must be allowed in this case (see `Section.isAllowOverlap()`).
  Version:
    IFS 1.3 (Instructor Sectioning)
    Copyright (C) 2016 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimeOverlaps()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getAbbreviation()` Abbreviated name of the criterion for `Object.toString()`.
    `void` | `getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Map<String,String> info)` Adds some information into the table with information about the solution
    `void` | `getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Map<String,String> info, Collection<TeachingRequest.Variable> variables)` Adds some information into the table with information about the solution, only consider variables from the given set
    `double` | `getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Collection<TeachingRequest.Variable> variables)` Value of a part of the problem (given by the collection of variables)
    `double` | `getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, TeachingAssignment value, Set<TeachingAssignment> conflicts)` Value of a proposed assignment (including hard conflicts)
    `double` | `getWeightDefault(DataProperties config)` Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).

    - ### Methods inherited from class org.cpsolver.instructor.criteria.InstructorSchedulingCriterion

      `getAssignedInstructors, getInstructors`

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, computeBounds, configure, constraintAdded, constraintRemoved, createAssignmentContext, getAssignmentContextReference, getBest, getBounds, getBounds, getBounds, getBounds, getContext, getContext, getExtendedInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TimeOverlaps

          public TimeOverlaps()

  - ### Method Detail

    - #### getWeightDefault

          public double getWeightDefault(DataProperties config)

      Description copied from class: `AbstractCriterion`
      Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
      Overrides:
        `getWeightDefault` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `config` - solver configuration
      Returns:
        default criterion weight value

    - #### getValue

          public double getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                 TeachingAssignment value,
                                 Set<TeachingAssignment> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)
      Parameters:
        `assignment` - current assignment
        `value` - given value
        `conflicts` - values conflicting with the given value
      Returns:
        change in this criterion value when assigned

    - #### getValue

          public double getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                 Collection<TeachingRequest.Variable> variables)

      Description copied from interface: `Criterion`
      Value of a part of the problem (given by the collection of variables)
      Specified by:
        `getValue` in interface `Criterion<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getValue` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        value of the given variables

    - #### getAbbreviation

          public String getAbbreviation()

      Description copied from class: `AbstractCriterion`
      Abbreviated name of the criterion for `Object.toString()`.
      Overrides:
        `getAbbreviation` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Returns:
        abbreviated name of the criterion

    - #### getInfo

          public void getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                              Map<String,String> info)

      Description copied from interface: `InfoProvider`
      Adds some information into the table with information about the solution
      Specified by:
        `getInfo` in interface `InfoProvider<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getInfo` in class `InstructorSchedulingCriterion`
      Parameters:
        `assignment` - current assignment
        `info` - info table

    - #### getInfo

          public void getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                              Map<String,String> info,
                              Collection<TeachingRequest.Variable> variables)

      Description copied from interface: `InfoProvider`
      Adds some information into the table with information about the solution, only consider variables from the given set
      Specified by:
        `getInfo` in interface `InfoProvider<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getInfo` in class `InstructorSchedulingCriterion`
      Parameters:
        `assignment` - current assignment
        `info` - info table
        `variables` - sub-problem